//
//  GLPointWithColor.h
//  ImageFunGL
//
//  Created by Tom Bernard on 5/22/07.
//  Copyright 2007 Bersearch Information Services. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/gl.h>

extern NSString *glpwcXKey;
extern NSString *glpwcYKey;
extern NSString *glpwcZKey;

extern NSString *glpwcDxKey;
extern NSString *glpwcDyKey;
extern NSString *glpwcDzKey;

extern NSString *glpwcRedKey;
extern NSString *glpwcGreenKey;
extern NSString *glpwcBlueKey;
extern NSString *glpwcAlphaKey;



@interface GLPointWithColor : NSObject <NSCoding>
{
	GLdouble x, y, z;
	GLdouble dx;
	GLdouble dy;
	GLdouble dz;
		
	GLdouble red, green, blue, alpha;
	NSColor *color;
}

// class methods

+ (id)pointWithX:(GLdouble)_x
			   y:(GLdouble)_y
			   z:(GLdouble)_z
			 red:(GLdouble)_red
		   green:(GLdouble)_green
			blue:(GLdouble)_blue
		   alpha:(GLdouble)_alpha;

+ (id)pointWithX:(GLdouble)_x
			   y:(GLdouble)_y
			   z:(GLdouble)_z
		   color:(NSColor *)_color;

+ (id)pointWithX:(GLdouble)_x
			   y:(GLdouble)_y
			   z:(GLdouble)_z;

// instance methods

// initializers
- (id)initWithX:(GLdouble)_x
			  y:(GLdouble)_y
			  z:(GLdouble)_z
			red:(GLdouble)_red
		  green:(GLdouble)_green
		   blue:(GLdouble)_blue
		  alpha:(GLdouble)_alpha;

- (id)initWithX:(GLdouble)_x
			  y:(GLdouble)_y
			  z:(GLdouble)_z
		  color:(NSColor *)_color;

- (id)initWithX:(GLdouble)_x
			  y:(GLdouble)_y
			  z:(GLdouble)_z;

// render and animate
- (void)render;
- (void)animate;

// animation accessors

- (void)getDx:(GLdouble *)_dx dy:(GLdouble *)_dy dz:(GLdouble *)_dz;
- (void)setDx:(GLdouble)_dx dy:(GLdouble)_dy dz:(GLdouble)_dz;

// accessors

- (GLdouble)x;
- (void)setX:(GLdouble)_x;

- (GLdouble)y;
- (void)setY:(GLdouble)_y;

- (GLdouble)z;
- (void)setZ:(GLdouble)_z;

- (GLdouble)red;
- (void)setRed:(GLdouble)_red;

- (GLdouble)green;
- (void)setGreen:(GLdouble)_green;

- (GLdouble)blue;
- (void)setBlue:(GLdouble)_blue;

- (GLdouble)alpha;
- (void)setAlpha:(GLdouble)_alpha;

- (NSColor *)color;
- (void)setColor:(NSColor *)_color;

@end


/*
- (GLdouble);
- (void)set:(GLdouble);

 */
