//
//  ImageFunGLOpenGLView.h
//  ImageFunGL
//
//  Created by Tom Bernard on 5/21/07.
//  Copyright Bersearch Information Services 2007. All rights reserved.
//


#import <Cocoa/Cocoa.h>
#import <OpenGL/gl.h>

extern NSString *ifgloglvPointPairArrayKey;
extern GLdouble edgeOfUniverse;

@class GLPointPair;
@class ImageFunGLDocument;
@interface ImageFunGLOpenGLView : NSOpenGLView
{
	IBOutlet ImageFunGLDocument * imageFunGLDocument;
	
	BOOL inited;
	long swap_enabled;
	NSTimer *animationTimer;
	NSArray *pointPairArray;
	
	
	//		lifted from Assimmilator, by Brian Nenninger
	double basedist;
	double maxup, maxrt;
	
	double xangle, yangle, zangle;
	double dxang, dyang, dzang;
	double pi, pi2;
	
	
	double rtoff, upoff;
	double drt, dup;
	
	double px, py, pz; // camera position
	double fx, fy, fz; // camera "forward"
	double ux, uy, uz; // camera "up"
	double rx, ry, rz; // camera "right"
	double offx, offy;
	
	//		/lifted from Assimmilator, by Brian Nenninger
}

//		openGL staples

- (id)initWithFrame:(NSRect)frameRect
		pixelFormat:(NSOpenGLPixelFormat*)format;

- (id)initWithFrame:(NSRect)frameRect;
- (void)delayedInit;
- (void)reshape;
- (void)drawRect:(NSRect)rect;

//		/openGL staples

- (void)startAnimation;
- (void)generatePointPairs;

- (void)calculateCameraPosition;
- (void)animate:(NSTimer *)timer;
- (void)animatePointPairs;
- (void)generatePointPairs;

- (NSArray *)pointPairArray;
- (void)setPointPairArray:(NSArray *)_array;

@end


/*
 portions lifted from Assimilator, by Brian Nenninger of Dozing Cat Software, and are used by permission. Thank you, Brian.
 
 see http://www.dozingcatsoftware.com/ for more information.
 
 */

/* Assimilator Copyright */
/* Copyright 2001 by Brian Nenninger

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
